#include <Window.h>
#include <Roster.h>
#include "MTextAddOn.h"
#include <stdio.h>

extern "C" _EXPORT status_t perform_edit(MTextAddOn *mtex);

char *args[] = 
{
	"application/x-witt-bebookfetcher",
	"set",
	"Value",
	"of",
	"View",  
	"0",
	"of",
	"View",
	"0",
	"of",
	"Window",
	"0", 
	"to", 
	""	
};
//--------------------------------------------------------------------
bool IsAnUpperOrLowerOrUnderbarDigit(const char thedigit)
{
	bool result = true;
	if (thedigit < 'A')
	{
		result = false;
	}
	else
	{
		if (thedigit > 'z')
			result = false;
		else
		{
			if (thedigit < 'a')
				if (thedigit > 'Z')
					if (thedigit != '_')
						result = false;
		}
	}
	return result;
}
//--------------------------------------------------------------------
int32 CreateSelection(MTextAddOn *mtex, int32 &start)
{
	int32 end = start;

	while(IsAnUpperOrLowerOrUnderbarDigit(mtex->Text()[start - 1]))
		start--;	
	
	while(IsAnUpperOrLowerOrUnderbarDigit(mtex->Text()[end]))
		end++;
		
	return (end - start);	
}
//--------------------------------------------------------------------
extern "C" status_t perform_edit(MTextAddOn *mtex)
{
	status_t err = B_OK;
	
	int32 start,
		  end;
	
	mtex->GetSelection(&start, &end);
	
	int32 length = end - start;
	
	if (length == 0)
	{
		length = CreateSelection(mtex, start);
	}
	
	char *selection = new char[length + 1];
	
	for(int i = 0; i < length; i++)
	{
		selection[i] = mtex->Text()[start + i];
	}
	selection[length] = 0;
	
	args[13] = selection;
	
	fprintf(stderr, "string %s\n", selection);

	be_roster->Launch( "application/x-witt-bebookfetcher" );
	
	if (length)
		err = be_roster->Launch( "application/x-amezei-hey", 14, args );

	return err;
}
//--------------------------------------------------------------------

